> ## Documentation Index
> Fetch the complete documentation index at: https://docs.authsignal.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Rule

> Creates a rule for an action configuration.



## OpenAPI

````yaml management-api POST /action_configurations/{action_code}/rules
openapi: 3.1.0
info:
  description: Authsignal's Management API
  version: 1.0.0
  title: Management Api
  termsOfService: https://www.authsignal.com/legal/terms-of-service
  contact:
    email: hello@authsignal.com
servers:
  - url: https://api.authsignal.com/v1/management
    description: Authsignal's US (Oregon) Management API
  - url: https://au.api.authsignal.com/v1/management
    description: Authsignal's AU (Sydney) Management API
  - url: https://eu.api.authsignal.com/v1/management
    description: Authsignal's EU (Ireland) Management API
  - url: https://ca.api.authsignal.com/v1/management
    description: Authsignal's CA (Montreal) Management API
security:
  - basicAuth: []
tags:
  - name: Tenant
    description: Endpoints related to the configuration of a tenant.
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: Action Configurations
    description: Endpoints related to the configuration of action configurations.
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: Rules
    description: Endpoints related to the configuration of rules.
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: Theme
    description: Endpoints related to the configuration of a Tenant's theme.
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
externalDocs:
  description: Find out more about Authsignal
  url: https://docs.authsignal.com
paths:
  /action_configurations/{action_code}/rules:
    post:
      tags:
        - Rules
      summary: Create Rule
      description: Creates a rule for an action configuration.
      operationId: createRule
      parameters:
        - in: path
          name: action_code
          schema:
            type: string
          required: true
          description: The action code used to identify the action configuration.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateRuleBody'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RuleResponseBody'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
components:
  schemas:
    CreateRuleBody:
      type: object
      properties:
        name:
          type: string
        description:
          type: string
        isActive:
          type: boolean
        priority:
          type: integer
          minimum: 0
          maximum: 99
        type:
          type: string
          enum:
            - ALLOW
            - BLOCK
            - CHALLENGE
            - REVIEW
        conditions:
          type: object
        verificationMethods:
          type: array
          items:
            type: string
            enum:
              - SMS
              - AUTHENTICATOR_APP
              - RECOVERY_CODE
              - EMAIL_MAGIC_LINK
              - EMAIL_OTP
              - PUSH
              - DEVICE
              - SECURITY_KEY
              - PASSKEY
              - VERIFF
              - IPROOV
              - PALM_BIOMETRICS_RR
        promptToEnrollVerificationMethods:
          type: array
          items:
            type: string
            enum:
              - PASSKEY
        defaultVerificationMethod:
          type: string
          enum:
            - SMS
            - AUTHENTICATOR_APP
            - RECOVERY_CODE
            - UpdateRuleBody"EMAIL_MAGIC_LINK"
            - EMAIL_OTP
            - PUSH
            - DEVICE
            - SECURITY_KEY
            - PASSKEY
            - VERIFF
            - IPROOV
            - PALM_BIOMETRICS_RR
      required:
        - name
        - isActive
        - priority
        - type
        - conditions
    RuleResponseBody:
      type: object
      properties:
        name:
          type: string
        description:
          type: string
        isActive:
          type: boolean
        priority:
          type: integer
          minimum: 0
          maximum: 99
        tenantId:
          type: string
        ruleId:
          type: string
        type:
          type: string
          enum:
            - ALLOW
            - BLOCK
            - CHALLENGE
            - REVIEW
        conditions:
          type: object
        verificationMethods:
          type: array
          items:
            type: string
            enum:
              - SMS
              - AUTHENTICATOR_APP
              - RECOVERY_CODE
              - EMAIL_MAGIC_LINK
              - EMAIL_OTP
              - PUSH
              - DEVICE
              - SECURITY_KEY
              - PASSKEY
              - VERIFF
              - IPROOV
              - PALM_BIOMETRICS_RR
        promptToEnrollVerificationMethods:
          type: array
          items:
            type: string
            enum:
              - PASSKEY
        defaultVerificationMethod:
          type: string
          enum:
            - SMS
            - AUTHENTICATOR_APP
            - RECOVERY_CODE
            - EMAIL_MAGIC_LINK
            - EMAIL_OTP
            - PUSH
            - DEVICE
            - SECURITY_KEY
            - PASSKEY
            - VERIFF
            - IPROOV
            - PALM_BIOMETRICS_RR
    ErrorResponse:
      type: object
      properties:
        error:
          type: string
        errorDescription:
          type: string
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic
      description: >-
        Use your Authsignal Management API secret key as the username and leave
        the password empty. This key is different from the Server API key and
        can be found in the API Keys section of the Authsignal Portal settings
        page.

````